﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Razor_File_Download.Models;

using System.IO;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace Razor_File_Download.Pages
{
    public class IndexModel : PageModel
    {
        public List<FileModel> Files { get; set; }
        private IHostingEnvironment Environment;
        public IndexModel(IHostingEnvironment _environment)
        {
            this.Environment = _environment;
        }

        public void OnGet()
        {
            //Fetch all files in the Folder (Directory).
            string[] filePaths = Directory.GetFiles(Path.Combine(this.Environment.WebRootPath, "Files/"));

            //Copy File names to Model collection.
            this.Files = new List<FileModel>();
            foreach (string filePath in filePaths)
            {
                this.Files.Add(new FileModel { FileName = Path.GetFileName(filePath) });
            }
        }

        public FileResult OnGetDownloadFile(string fileName)
        {
            //Build the File Path.
            string path = Path.Combine(this.Environment.WebRootPath, "Files/") + fileName;

            //Read the File data into Byte Array.
            byte[] bytes = System.IO.File.ReadAllBytes(path);

            //Send the File to Download.
            return File(bytes, "application/octet-stream", fileName);
        }
    }
}